﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="2_ClientSideAjax.aspx.cs" Inherits="AjaxApplication.__ClientSideAjax" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Client-Side Ajax</title>
    <link href="Design/Site.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        
        .sys-template
        {
            display:none;
        }
        
    </style>
    
    
    <!-- Include ASP.NET AJAX JavaScript Libraries -->
    <script src="MicrosoftAjax/MicrosoftAjax.debug.js" type="text/javascript"></script>
    <script src="MicrosoftAjax/MicrosoftAjaxTemplates.debug.js" type="text/javascript"></script>

    <!-- Add Service reference -->
    <script src="Services/MovieService.asmx/jsdebug" type="text/javascript"></script>


</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    
    <script type="text/javascript">

        var ddlCategory;
        var movieView;


        function pageLoad()
        {
            // Assign category dropdown list to page variable
            ddlCategory = $get("<%= ddlCategory.ClientID %>");        
            
            // Create Movie DataView
            movieView = $create(Sys.UI.DataView, {}, {}, {}, $get("movieBody"));
            
            // Show initial movies
            showMovies();
            
            // Add handler for picking new movie category
            $addHandler(ddlCategory, "change", showMovies);
        }


        function showMovies()
        {
            // Get selected movie category
            var categoryId = ddlCategory.value;
    
            // Call web service to get movies from database
            AjaxApplication.Services.MovieService.GetMovies(categoryId, showMoviesComplete);                   
        }


        function showMoviesComplete(data)
        {
           // Display data in Movies DataView
           movieView.set_data(data);
        }
    
    </script>


    <asp:DropDownList
        id="ddlCategory"
        DataSourceID="srcCategories"
        DataTextField="Name"
        DataValueField="Id"
        Runat="server" />
    
    <br /><br />

    <table>
    <thead>
        <tr>
            <th>Title</th><th>Director</th><th>Date Released</th>
        </tr>
    </thead>
    <tbody id="movieBody" class="sys-template">
    <tr>
        <td>{{ Title }}</td>
        <td>{{ Director }}</td>
        <td>{{ DateReleased.localeFormat("D") }}</td>        
    </tr>
    </tbody>
    </table>

    <br />
    Page Generated: <%= DateTime.Now.ToString("T") %>


    
    <asp:SqlDataSource
        id="srcCategories"
        SelectCommand="SELECT Id, Name FROM MovieCategories"
        ConnectionString="<%$ ConnectionStrings:conMovies %>"
        Runat="server" />
    
    
    </div>
    </form>
</body>
</html>
