﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="3_Failover.aspx.cs" Inherits="AjaxApplication.__Failover" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title>Client-Side Ajax</title>
    <link href="Design/Site.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        
        .sys-template
        {
            display:none;
        }
        
    </style>
    
    
    <!-- Include ASP.NET AJAX JavaScript Libraries -->
    <script src="MicrosoftAjax/MicrosoftAjax.debug.js" type="text/javascript"></script>
    <script src="MicrosoftAjax/MicrosoftAjaxTemplates.debug.js" type="text/javascript"></script>

    <!-- Add Service reference -->
    <script src="Services/MovieService.asmx/jsdebug" type="text/javascript"></script>


</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    
    <script type="text/javascript">

        var ddlCategory;
        var movieView;


        function pageLoad()
        {
            // Assign category dropdown list to page variable
            ddlCategory = $get("<%= ddlCategory.ClientID %>");        
            
            // Create Movie DataView
            movieView = $create(Sys.UI.DataView, {}, {}, {}, $get("movieBody"));

            // Specify template
            movieView.set_itemTemplate($get("movieTemplate"));
                      
            // Add handler for picking new movie category
            $addHandler(ddlCategory, "change", showMovies);
        }


        function showMovies()
        {
            // Get selected movie category
            var categoryId = ddlCategory.value;
    
            // Call web service to get movies from database
            AjaxApplication.Services.MovieService.GetMovies(categoryId, showMoviesComplete);                   
        }


        function showMoviesComplete(data)
        {
           // Display data in Movies DataView
           movieView.set_data(data);
        }
    
    </script>


    <asp:DropDownList
        id="ddlCategory"
        DataSourceID="srcCategories"
        DataTextField="Name"
        DataValueField="Id"
        Runat="server" />
    <asp:Button
        id="btnSelect"
        Text="Select"
        Runat="Server" />
    
    <br /><br />


    <asp:ListView
        id="grdMovies"
        DataSourceID="srcMovies"
        Runat="server">
        <LayoutTemplate>
        <table>
        <thead>
            <tr>
                <th>Title</th><th>Director</th><th>Date Released</th>
            </tr>
        </thead>
        <tbody id="movieBody">
            <asp:Placeholder id="itemPlaceholder" runat="server"/>        
        </tbody>
        </table>
        </LayoutTemplate>
        <ItemTemplate>
            <tr>
                <td><%# Eval("Title") %></td>
                <td><%# Eval("Director") %></td>
                <td><%# Eval("DateReleased", "{0:D}") %></td>                
            </tr>
        </ItemTemplate>
    </asp:ListView>    



    <br />
    Page Generated: <%= DateTime.Now.ToString("T") %>


    
    <asp:SqlDataSource
        id="srcCategories"
        SelectCommand="SELECT Id, Name FROM MovieCategories"
        ConnectionString="<%$ ConnectionStrings:conMovies %>"
        Runat="server" />
    

    <asp:SqlDataSource
        id="srcMovies"
        SelectCommand="SELECT Title, Director, DateReleased 
            FROM Movies WHERE CategoryId = @CategoryId"
        ConnectionString="<%$ ConnectionStrings:conMovies %>"
        Runat="server">
        <SelectParameters>
            <asp:ControlParameter
                Name="CategoryId"
                ControlID="ddlCategory" />
        </SelectParameters>
    </asp:SqlDataSource>    

    <table>
    <tbody id="movieTemplate" class="sys-template">
    <tr>
        <td>{{ Title }}</td>
        <td>{{ Director }}</td>
        <td>{{ DateReleased.localeFormat("D") }}</td>        
    </tr>
    </tbody>
    </table>

    
    </div>
    </form>
</body>
</html>
