// ----------------------------------------------------------------------------------
// Microsoft Developer & Platform Evangelism
// 
// Copyright (c) Microsoft Corporation. All rights reserved.
// 
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
// OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
// ----------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
// ----------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Data.Objects;
using System.Data.Objects.DataClasses;
using System.Data.EntityClient;
using System.ComponentModel;
using System.Xml.Serialization;
using System.Runtime.Serialization;

[assembly: EdmSchemaAttribute()]

#region EDM Relationship Metadata
[assembly: EdmRelationshipAttribute("Models", "FK_Movies_MovieCategories", "MovieCategories", System.Data.Metadata.Edm.RelationshipMultiplicity.One, typeof(AjaxApplication.MovieCategory), "Movies", System.Data.Metadata.Edm.RelationshipMultiplicity.Many, typeof(AjaxApplication.Movie))]
#endregion

namespace AjaxApplication
{
    #region Contexts
    /// <summary>
    /// No Metadata Documentation available.
    /// </summary>
    public partial class MoviesDBEntities : ObjectContext
    {
        #region Constructors
        /// <summary>
        /// Initializes a new MoviesDBEntities object using the connection string found in the 'MoviesDBEntities' section of the application configuration file.
        /// </summary>
        public MoviesDBEntities() : base("name=MoviesDBEntities", "MoviesDBEntities")
        {
            OnContextCreated();
        }
    
        /// <summary>
        /// Initialize a new MoviesDBEntities object.
        /// </summary>
        public MoviesDBEntities(string connectionString) : base(connectionString, "MoviesDBEntities")
        {
            OnContextCreated();
        }
    
        /// <summary>
        /// Initialize a new MoviesDBEntities object.
        /// </summary>
        public MoviesDBEntities(EntityConnection connection) : base(connection, "MoviesDBEntities")
        {
            OnContextCreated();
        }
        #endregion
        
        #region Partial Methods
        partial void OnContextCreated();
        #endregion
        
        #region ObjectSet Properties
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        public ObjectSet<MovieCategory> MovieCategorySet
        {
            get
            {
                if ((_MovieCategorySet == null))
                {
                    _MovieCategorySet = base.CreateObjectSet<MovieCategory>("MovieCategorySet");
                }
                return _MovieCategorySet;
            }
        }
        private ObjectSet<MovieCategory> _MovieCategorySet;
    
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        public ObjectSet<Movie> MovieSet
        {
            get
            {
                if ((_MovieSet == null))
                {
                    _MovieSet = base.CreateObjectSet<Movie>("MovieSet");
                }
                return _MovieSet;
            }
        }
        private ObjectSet<Movie> _MovieSet;
    
        #endregion
        #region AddTo Methods
            
        /// <summary>
        /// Deprecated Method for adding a new object to the MovieCategorySet EntitySet. Consider using the .Add method of the associated ObjectSet&lt;T&gt; property instead.
        /// </summary>
        public void AddToMovieCategorySet(MovieCategory movieCategory)
        {
            base.AddObject("MovieCategorySet", movieCategory);
        }
            
        /// <summary>
        /// Deprecated Method for adding a new object to the MovieSet EntitySet. Consider using the .Add method of the associated ObjectSet&lt;T&gt; property instead.
        /// </summary>
        public void AddToMovieSet(Movie movie)
        {
            base.AddObject("MovieSet", movie);
        }
        #endregion
    }
    
    #endregion
    
    
    #region Entities
    /// <summary>
    /// No Metadata Documentation available.
    /// </summary>
    [EdmEntityTypeAttribute(NamespaceName="Models", Name="Movie")]
    [Serializable()]
    [DataContractAttribute(IsReference=true)]
    public partial class Movie : EntityObject
    {
        #region Factory Method
        /// <summary>
        /// Create a new Movie object.
        /// </summary>
        /// <param name="id">Initial value of the Id property.</param>
        /// <param name="title">Initial value of the Title property.</param>
        /// <param name="director">Initial value of the Director property.</param>
        /// <param name="dateReleased">Initial value of the DateReleased property.</param>
        public static Movie CreateMovie(global::System.Int32 id, global::System.String title, global::System.String director, global::System.DateTime dateReleased)
        {
            Movie movie = new Movie();
            movie.Id = id;
            
            movie.Title = title;
            
            movie.Director = director;
            
            movie.DateReleased = dateReleased;
            
            return movie;
        }
        #endregion

        #region Primitive Properties
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=true, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.Int32 Id
        {
            get
            {
                return _Id;
            }
            set
            {
                if (Id != value)
                {
                    OnIdChanging(value);
                    ReportPropertyChanging("Id");
                    _Id = StructuralObject.SetValidValue(value);
                    ReportPropertyChanged("Id");
                    OnIdChanged();
                }
            }
                
        }
        private global::System.Int32 _Id;
        partial void OnIdChanging(global::System.Int32 value);
        partial void OnIdChanged();
        
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=false, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.String Title
        {
            get
            {
                return _Title;
            }
            set
            {
                OnTitleChanging(value);
                ReportPropertyChanging("Title");
                _Title = StructuralObject.SetValidValue(value, false);
                ReportPropertyChanged("Title");
                OnTitleChanged();
            }
                
        }
        private global::System.String _Title;
        partial void OnTitleChanging(global::System.String value);
        partial void OnTitleChanged();
        
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=false, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.String Director
        {
            get
            {
                return _Director;
            }
            set
            {
                OnDirectorChanging(value);
                ReportPropertyChanging("Director");
                _Director = StructuralObject.SetValidValue(value, false);
                ReportPropertyChanged("Director");
                OnDirectorChanged();
            }
                
        }
        private global::System.String _Director;
        partial void OnDirectorChanging(global::System.String value);
        partial void OnDirectorChanged();
        
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=false, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.DateTime DateReleased
        {
            get
            {
                return _DateReleased;
            }
            set
            {
                OnDateReleasedChanging(value);
                ReportPropertyChanging("DateReleased");
                _DateReleased = StructuralObject.SetValidValue(value);
                ReportPropertyChanged("DateReleased");
                OnDateReleasedChanged();
            }
                
        }
        private global::System.DateTime _DateReleased;
        partial void OnDateReleasedChanging(global::System.DateTime value);
        partial void OnDateReleasedChanged();
        
        #endregion
    
        #region Navigation Properties
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [XmlIgnoreAttribute()]
        [SoapIgnoreAttribute()]
        [DataMemberAttribute()]
        [EdmRelationshipNavigationPropertyAttribute("Models", "FK_Movies_MovieCategories", "MovieCategories")] 
        public MovieCategory MovieCategory
        {
            get
            {
                return ((IEntityWithRelationships)this).RelationshipManager.GetRelatedReference<MovieCategory>("Models.FK_Movies_MovieCategories", "MovieCategories").Value;
            }
            set
            {
                ((IEntityWithRelationships)this).RelationshipManager.GetRelatedReference<MovieCategory>("Models.FK_Movies_MovieCategories", "MovieCategories").Value = value;
            }
        }
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [BrowsableAttribute(false)]
        [DataMemberAttribute()]
        public EntityReference<MovieCategory> MovieCategoryReference
        {
            get
            {
                return ((IEntityWithRelationships)this).RelationshipManager.GetRelatedReference<MovieCategory>("Models.FK_Movies_MovieCategories", "MovieCategories");
            }
            set
            {
                if ((value != null))
                {
                    ((IEntityWithRelationships)this).RelationshipManager.InitializeRelatedReference<MovieCategory>("Models.FK_Movies_MovieCategories", "MovieCategories", value);
                }
            }
        }
        #endregion
    }
    
    /// <summary>
    /// No Metadata Documentation available.
    /// </summary>
    [EdmEntityTypeAttribute(NamespaceName="Models", Name="MovieCategory")]
    [Serializable()]
    [DataContractAttribute(IsReference=true)]
    public partial class MovieCategory : EntityObject
    {
        #region Factory Method
        /// <summary>
        /// Create a new MovieCategory object.
        /// </summary>
        /// <param name="id">Initial value of the Id property.</param>
        /// <param name="name">Initial value of the Name property.</param>
        public static MovieCategory CreateMovieCategory(global::System.Int32 id, global::System.String name)
        {
            MovieCategory movieCategory = new MovieCategory();
            movieCategory.Id = id;
            
            movieCategory.Name = name;
            
            return movieCategory;
        }
        #endregion

        #region Primitive Properties
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=true, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.Int32 Id
        {
            get
            {
                return _Id;
            }
            set
            {
                if (Id != value)
                {
                    OnIdChanging(value);
                    ReportPropertyChanging("Id");
                    _Id = StructuralObject.SetValidValue(value);
                    ReportPropertyChanged("Id");
                    OnIdChanged();
                }
            }
                
        }
        private global::System.Int32 _Id;
        partial void OnIdChanging(global::System.Int32 value);
        partial void OnIdChanged();
        
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [EdmScalarPropertyAttribute(EntityKeyProperty=false, IsNullable=false)]
        [DataMemberAttribute()]
        public global::System.String Name
        {
            get
            {
                return _Name;
            }
            set
            {
                OnNameChanging(value);
                ReportPropertyChanging("Name");
                _Name = StructuralObject.SetValidValue(value, false);
                ReportPropertyChanged("Name");
                OnNameChanged();
            }
                
        }
        private global::System.String _Name;
        partial void OnNameChanging(global::System.String value);
        partial void OnNameChanged();
        
        #endregion
    
        #region Navigation Properties
        /// <summary>
        /// No Metadata Documentation available.
        /// </summary>
        [XmlIgnoreAttribute()]
        [SoapIgnoreAttribute()]
        [DataMemberAttribute()]
        [EdmRelationshipNavigationPropertyAttribute("Models", "FK_Movies_MovieCategories", "Movies")] 
        public EntityCollection<Movie> Movies
        {
            get
            {
                return ((IEntityWithRelationships)this).RelationshipManager.GetRelatedCollection<Movie>("Models.FK_Movies_MovieCategories", "Movies");
            }
            set
            {
                if ((value != null))
                {
                    ((IEntityWithRelationships)this).RelationshipManager.InitializeRelatedCollection<Movie>("Models.FK_Movies_MovieCategories", "Movies", value);
                }
            }
        }
        #endregion
    }
    
    #endregion
    
}